/**
 * Netwosix Web Admin - libal
 * Copyright (C) 2006 netwosix team
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 * If you want to contact e-mail at info@netwosix.org
 */


#include "al.h"



/**
 */
void al_stdio_connection_manager_delete(AlConnectionManager * connection_manager)
{

	al_return_if_fail (connection_manager);
	al_delete(connection_manager);

}


/**
 */
AlConnectionManager * al_stdio_connection_manager_new(void)
{
	AlConnectionManager * connection = al_new(AlConnectionManager);

	connection->wait = al_stdio_connection_wait;
	connection->close = al_stdio_connection_close;
	connection->read = al_stdio_connection_read;
	connection->send = al_stdio_connection_send;
	connection->del = al_stdio_connection_manager_delete;
	connection->conn = al_stdio_connection_connect;

	connection->data = NULL;
	connection->fork = 0;

	return connection;
}


/**
 */
AlConnection * al_stdio_connection_wait(AlConnectionManager * connection_manager)
{
	static AlConnection * ret = NULL;


	al_return_val_if_fail(connection_manager, NULL);

	if (ret == NULL)
	{
		ret = al_new(AlConnection);
		ret->connection_manager = connection_manager;
	}
	else
	{
		ret = NULL;
	}

	return ret;
}


/**
 */
void al_stdio_connection_close(AlConnection * connection)
{
}


/**
 */
AlString * al_stdio_connection_read(AlConnection * connection)
{
	AlString    * s = NULL;
	static char   first = 0;


	al_return_val_if_fail(connection, NULL);

	if (!first)
	{
		first = 1;
		s = al_read_file(stdin);
	}

	return s;
}


/**
 */
void al_stdio_connection_send(AlConnection * connection, const AlString * packet)
{
	al_return_if_fail(connection && packet);


	printf("%s", al_string_get(packet));

}


/**
 */
AlConnection * al_stdio_connection_connect(AlConnectionManager * connection_manager, const char * server)
{
	return NULL;
}
